<script lang="ts">
  import { fade } from 'svelte/transition'
  import type { RouteParams } from 'typescript-router'
  import type { AppRouter } from 'src/components/router'
  import Shape from 'src/components/shape/shape.svelte'
  import { ApiShape, apiShape } from 'shared/model/shape'
  import { vfetch, VFetchResult } from 'src/utils/fetch'

  type BlueData = VFetchResult<ApiShape> | undefined

  export function fetchBlueData(id: string): Promise<BlueData> {
    return vfetch(`${appEnv.backendUrl}/api/shapesPg/${id}`, { ok: apiShape })
  }

  export let params: RouteParams<AppRouter, 'shape'>

  let data: BlueData = undefined

  $: fetchBlueData(params.id).then(d => (data = d))
</script>

<style>
  blue {
    display: block;
    background-color: #6666ff;
    color: white;
    width: 300px;
    height: 200px;
    padding: 8px;
  }
</style>

<blue in:fade={{ duration: 120 }}>
  <h2>Shape #{params.id}</h2>

  {#if !data}
    Loading...
  {:else if !data.ok}
    <p>Error... ({JSON.stringify(data.error, null, 2)})</p>
  {:else}
    <Shape data={data.value} />
  {/if}
</blue>
